# -*- coding: utf-8 -*-
#ABSSmileysPack.py
#Дополнительны смайлы ABitSmileys

import re, os
import base

abs1 = {
"page":"biggrinsanta",
"target":"advsmile",
"caption":u"ABitSmileys biggrinsanta",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [  "abs_smile1","abs_podmigivaju","abs_wink","abs_biggrinsanta","abs_lol","abs_smeh3","abs_sad","abs_blink","abs_ao","abs_jazik","abs_oo","abs_hi","abs_hi1","abs_privetik" ]
    ]
}
abs2 = {
"page":"abscensored",
"target":"advsmile",
"caption":u"ABitSmileys censored",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_sleepy", "abs_rest","abs_ku","abs_bye","abs_skromnij","abs_negation","abs_pardon","abs_read","abs_ranting","abs_devil","abs_censored" ]
    ]
}
abs3 = {
"page":"abscrazy",
"target":"advsmile",
"caption":u"ABitSmileys crazy",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_crazy","abs_crazy1","abs_no","abs_super","abs_palci","abs_nezachet","abs_crazy2","abs_steep","abs_smile2","abs_secret","abs_dont_know","abs_candle" ]
    ]
}
abs4 = {
"page":"absbravo",
"target":"advsmile",
"caption":u"ABitSmileys bravo",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        ["abs_eda","abs_athlete","abs_cry","abs_acute","abs_fool","abs_bravo","abs_sorry","abs_spiteful","abs_brick","abs_negro","abs_freeze"]
    ]
}

abs5 = {
"page":"happydance",
"target":"advsmile",
"caption":u"ABitSmileys happydance",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_show","abs_happy_dance","abs_dance","abs_hot","abs_boredom","abs_supermen","abs_beg","abs_be","abs_cannab","abs_icon_cry","abs_telefon" ]
    ]
}

abs6 = {
"page":"victory",
"target":"advsmile",
"caption":u"ABitSmileys victory",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_ambush","abs_fingal","abs_aggressive","abs_yess","abs_yu","abs_victory","abs_sun","abs_friends","abs_spider" ]
    ]
}

abs7 = {
"page":"rtfm",
"target":"advsmile",
"caption":u"ABitSmileys rtfm",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_opera","abs_scare","abs_rooters","abs_dance1","abs_rtfm" ]
    ]
}

abs8 = {
"page":"crazypilot",
"target":"advsmile",
"caption":u"ABitSmileys crazypilot",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_punish","abs_jar","abs_king","abs_pilot","abs_crazy_pilot","abs_recourse","abs_prosti","abs_bayan" ]
    ]
}

abs9 = {
"page":"boat",
"target":"advsmile",
"caption":u"ABitSmileys boat",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_bayan1","abs_boat","abs_cards","abs_flower","abs_cem","abs_nurse","abs_cem2","abs_circling" ]
    ]
}

abs10 = {
"page":"drink",
"target":"advsmile",
"caption":u"ABitSmileys drink",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_irritating","abs_curtsey","abs_drink","abs_drink1","abs_drinker","abs_fight","abs_girl","abs_kiss" ]
    ]
}

abs11 = {
"page":"pioneer",
"target":"advsmile",
"caption":u"ABitSmileys pioneer",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_kisskiss","abs_pioneer","abs_troop","abs_prig","abs_prig2","abs_prig3","abs_puh","abs_seat" ]
    ]
}

abs12 = {
"page":"shower",
"target":"advsmile",
"caption":u"ABitSmileys shower",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_shower","abs_shower2","abs_shut","abs_sigh" ]
    ]
}
abs13 = {
"page":"sos",
"target":"advsmile",
"caption":u"ABitSmileys sos",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_siski","abs_sos","abs_death","abs_vampire","abs_cat1" ]
    ]
}

abs14 = {
"page":"cat2",
"target":"advsmile",
"caption":u"ABitSmileys cat2",
"path":"pixmaps/smileys/abs/",
"prefix":"",
"smileys":[
        [ "abs_cat2","abs_fuckyou", "abs_use_search","abs_punish" ]
    ]
}

packs = [abs1,abs2,abs3,abs4,abs5,abs6,abs7,abs8,abs9,abs10,abs11,abs12,abs13,abs14]
class AdvancedSmileyPack(base.Baselugin):
    def __init__(self,parent,modulename,active):
        base.Baselugin.__init__(self,parent,modulename,active)
        self.name = "ABitSmileys"
        self.version = "v1.0"
        self.description =u"""ABitSmileys Pack."""
        self.smilemanager = parent.SmileyManager
        self.SetActive(active)
        parent.Worker.parseImages = self.parseImages(parent.Worker.parseImages)


    def SetActive(self,active = True): #Тут тоже делаем чего-то..
        self.active = active
        if self.active:
            for pack in packs:
                self.smilemanager.AddPage(pack)
        else:
            for pack in packs:
                self.smilemanager.DeletePage(pack)

    def replaceAdvSmile(self, m):
        imgpath = "pixmaps/smileys/abs/%s.gif" % m.group(2)
        if os.path.exists(imgpath):
            return '<glink href="%s" target="advsmile"><img src="%s"></glink>' % (m.group(2),imgpath)
        else:
            return ':(%s):' % m.group(2)

    def parseImages(self, parentparseImages):
        def wrapper(msg):
            if not self.active: return parentparseImages(msg)
            msg = re.sub('(?i)(:\((.+?)\):)', self.replaceAdvSmile, msg, 0)
            return parentparseImages(msg)
        return wrapper

